#!/usr/bin/python

import client
import crypto
import fs
import getpass
import jsonpickle
import profile
import sys

PATH_PROFILE = "profile/"
PROFILE_NONCE = "Securebox profile"

def console():
    print "Securebox 0.1"
    while True:
        sys.stdout.write("Username: ")
        username = sys.stdin.readline()[:-1]
        try:
            with open(PATH_PROFILE + username, "r") as inf:
                c = inf.read()
            while True:
                password = getpass.getpass()
                m = crypto.sdec(password, c)
                if m[:len(PROFILE_NONCE)] == PROFILE_NONCE:
                    break
                else:
                    print "Incorrect password. Please try again!"
            profile.profile = jsonpickle.decode(m[len(PROFILE_NONCE):])
            break
        except IOError:
            while True:
                sys.stdout.write("Profile doesn't exists. Are you sure to create a new profile: ")
                choice = sys.stdin.readline()[:-1]
                if choice == "y" or choice == "n":
                    break
                else:
                    print "Invalid choice. Please type \"y\" or \"n\"."
            if choice == 'y':
                password = getpass.getpass()
                profile.profile = profile.Profile(username)
                break
    fs.cd("")
    while True:
        sys.stdout.write(">>> ")
        args = sys.stdin.readline()[:-1].split()
        if len(args) == 0:
            continue
        elif args[0] == "bye" and len(args) == 1:
            with open(PATH_PROFILE + profile.profile.username, "w") as ouf:
                ouf.write(crypto.senc(password, PROFILE_NONCE + jsonpickle.encode(profile.profile)))
            break
        elif args[0] == "cd" and len(args) in [1, 2]:
            fs.cd("" if len(args) == 1 else args[1])
        elif args[0] == "get" and len(args) == 2:
            fs.get(args[1])
        elif args[0] == "help" and len(args) == 1:
            print "Available commands:"
            print "%-50s%s" % ("bye", "Quit Securebox")
            print "%-50s%s" % ("cd [<dir>]", "Change remote directory to 'dir'")
            print "%-50s%s" % ("get <fnm>", "Download file")
            print "%-50s%s" % ("help", "Display this help text")
            print "%-50s%s" % ("listacl", "List access control list")
            print "%-50s%s" % ("ls", "Display remote directory listing")
            print "%-50s%s" % ("mkdir <dir>", "Create remote directory")
            print "%-50s%s" % ("put <fnm>", "Upload file")
            print "%-50s%s" % ("pwd", "Display remote working directory")
            print "%-50s%s" % ("rm <fnm>", "Delete remote file")
            print "%-50s%s" % ("rmdir <dir>", "Remove remote directory")
            print "%-50s%s" % ("setacl <user> <none>/<read>/<write>", "Set access control list")
            print "%-50s%s" % ("state", "Display consistency state")
        elif args[0] == "listacl" and len(args) == 1:
            fs.listacl()
        elif args[0] == "ls" and len(args) == 1:
            fs.ls()
        elif args[0] == "mkdir" and len(args) == 2:
            fs.mkdir(args[1])
        elif args[0] == "put" and len(args) == 2:
            fs.put(args[1])
        elif args[0] == "pwd" and len(args) == 1:
            fs.pwd()
        elif args[0] == "rm" and len(args) == 2:
            fs.rm(args[1])
        elif args[0] == "rmdir" and len(args) == 2:
            fs.rmdir(args[1])
        elif args[0] == "setacl" and len(args) == 3:
            if not args[2] in ["none", "read", "write"]:
                print "Invalid permission. Type \"none\", \"read\" or \"write\"."
            else:
                fs.setacl(args[1], args[2])
        elif args[0] == "state" and len(args) == 1:
            fs.state()
        else:
            print "Invalid command or parameters. Type \"help\" for a list of all commands."

if __name__=="__main__":
    console()
