#!/usr/bin/python

import base64

from Crypto.Hash import SHA

def hash(m):
    sha = SHA.new()
    sha.update(m)
    return sha.hexdigest()

def pad(m, align):
    return '%s%s%s' % (m, '.', ' ' * ((align - len(m) - 1) % align))

def unpad(m):
    return m[:m.rfind('.')]

from Crypto.Random import random

def gen():
    return hash(str(random.getrandbits(160)))

from Crypto.Cipher import AES

def sgen():
    return gen()[:31]

def senc(sk, m):
    return base64.b64encode(AES.new(pad(sk, 16), AES.MODE_CBC).encrypt(pad(m, 16)))

def sdec(sk, c):
    return unpad(AES.new(pad(sk, 16), AES.MODE_CBC).decrypt(base64.b64decode(c)))
